<?php

/*

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.

 $Id: domain.php,v 1.21 2003/09/04 21:22:42 vollmerk Exp $
 $Source: /a1/cvsroot/maint/modules/class/domain.php,v $

 The domain class for domain manipulation and access.

*/

class Domain {
	var $id;
	var $name;
	var $master_domain;
	var $object_history;

	// we can populate this stuff from the database -- no sense in
	//   passing it in.
	function Domain ( $domain_id ) {
		global $conf;

		$this->id = $domain_id;

		if ($domain_id) {
			$info = $this->get_info();
		}

		if ( ! $info ) {
			return false;
		}

		// set all of the objects attributes
		$this->name	     = $info->name;
		$this->master_domain = $info->master_domain;

		$this->object_history = new ObjectHistory('domain', $this->id);
	} // Domain

	function get_info () {
		global $conf;

		$sql = "SELECT * FROM domain WHERE id='$this->id'";
		$db_result = mysql_query($sql, $conf['dbh']);
		
		return (mysql_fetch_object($db_result));

	} // get_info

	// I'm greedy give me ALL the domains
	function domains()
	{
		global $user, $conf;
		
		$sql = "SELECT * FROM domain ORDER BY name";
		$db_results = mysql_query($sql, $conf['dbh']);
		
		while ($d = mysql_fetch_object($db_results))
			{
			$domain = new Domain($d->id);
			$domains[] = $domain;
			}

		return $domains;
	} //domains
	
	// give me a list of the zones that are attached to this domain object
	function zones()
	{
		global $user, $conf;

		$sql = "SELECT * FROM zone_domain WHERE domain='$this->id'";
		$db_results = mysql_query($sql, $conf['dbh']);
		
		while ($z = mysql_fetch_object($db_results))
			{
			$zones[] = new Zone($z->zone);
			}
		return $zones;

	} //zones

	// Return an array of NS objects from record_ns if this
	//   domain is delegated.
	function get_ns () {
		global $conf;

		$sql = "SELECT id FROM nameserver WHERE domain='$this->id'";
		$db_result = mysql_query($sql, $conf['dbh']);

		$ns_arr = array();

		while ( $ns_id = mysql_fetch_object($db_result) ) {
			$ns = new NS($ns_id->id);
			$ns_arr[] = $ns;
		}

		return $ns_arr;
	}

	/*!
		@function get_domain_by_name
		@discussion takes a domain name and returns the domain_id
	*/
	function get_domain_by_name($name) {

		$sql = "SELECT id FROM domain WHERE name='$name'";
		$db_results = mysql_query($sql, dbh());

		$results = mysql_fetch_object($db_results);

		return $results->id;

	} // get_domain_by_name
	
	//check to make sure all the zone mojo is good
	function check_zone($zone_id) {
		
		global $user, $conf;

		$sql = "SELECT * FROM zone_domain WHERE zone='$zone_id' AND domain='$this->id'";
		$db_results = mysql_query($sql, $conf['dbh']); 
		
		if (!mysql_fetch_object($db_results)) { return true; }
		else { return false; }
	}

	//check to make sure the new domain name is a valid domain name
	function check_name($name,$domain_id) {
		global $conf;

		//first lets make sure it isn't a duplicate
		$sql = "SELECT id FROM domain WHERE name LIKE '$name' AND id!='$domain_id'";
		$db_results = mysql_query($sql, $conf['dbh']); 
		if (mysql_fetch_row($db_results)) {
			$conf['error']->add_error('domain_name', "Duplicate name: $name is already in use."); 
		}

		//now lets check the chrs
		if (!preg_match("/[\w]+\.[\w]+/", $name)) {
			$conf['error']->add_error('domain_name', "$name is an invalid Domain Name"); 
		}
		
	
	} //check_name

	//update the name of the domain. 
	function update_name($name)
	{ 
		global $conf, $user;

		$sql = "UPDATE domain SET name='$name' WHERE id='$this->id'";
		$db_results = mysql_query($sql, $conf['dbh']);

	} //update_name

	//nuke the domain itself
	function delete_domain($domain_id) {
	
		global $conf, $user;
		
		$sql = "DELETE FROM domain WHERE id='$domain_id'";
		$db_results = mysql_query($sql, $conf['dbh']);
	}

	//make a brand spanking new domain
	function new_domain($name, $master_domain = 0) {
		global $conf, $user;
		
		$sql = "INSERT INTO domain (name,master_domain) VALUES ('$name', $master_domain)";
		$db_results = mysql_query($sql, $conf['dbh']);
		
		$sql = "SELECT * FROM domain WHERE name='$name'";
		$db_results = mysql_query($sql, $conf['dbh']);
		
		$domain = mysql_fetch_object($db_results);
		
		return $domain->id;

	}

	//get all hosts in $this domain
	function get_hosts() {
		global $conf;

		$sql = "SELECT * FROM host WHERE domain='$this->id'";
		$db_results = mysql_query($sql, $conf['dbh']);
	
		while ($r = mysql_fetch_object($db_results)) {
			$host = new Host($r->id);
			$hosts[] = $host;
		}
	return $hosts;

	} //get_hosts

	// Accessor functions -- things only used by this class or for
	//    debugging purposes

	function _show () {
		print("Domain: id -> $this->id, name -> $this->name end Domain<br>\n");
	}

	function _debug () {
		if ( $this->debug ) {
			$this->debug = false;
		}
		else {
			$this->debug = true;
		}
	}
} // class Domain

?>
